#!/usr/bin/perl
# program to compile WOB files. See http://wob.sourceforge.com
# Copyright (c) 2000, John Hanna,
# This program may be distributed under the terms of this General Public
# License. THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED
# BY APPLICABLE LAW.
# http://www.opensource.org/licenses/gpl-license.html
# 

## set the following to enable these features
$CompiledOutput=''; ## file name for compiled output
$sqllog=''; ## file for logging SQL info

## this is the location of the directory to keep session data
$_sid_base='/home/groups/wob/sid/';

$_SID_TIMEOUT=60*60*2; ## sessions time out after 2 hours without use

use DBI;

&_init; # recover session or set cookie; read cgi
 $_head=<<EOHEAD;
<html>

<head>
<meta http-equiv="Content-Type"
content="text/html; charset=iso-8859-1">
<meta name="GENERATOR" content="Microsoft FrontPage Express 2.0">
<title>$title</title>
</head>

<body bgcolor="#FFFFFF">
EOHEAD
 $_paochk='Test|Home|Test2|About';
 $_base='Home';
 &_main;


sub _main {
## Main routine
 &Init if defined &Init; ## this is their init routine
 ## put in the title in the head
 $_head=~s/\$title/$_session{'go'} || $_base/ie;
 ## output the html header
 print $_head;
 ## do the go item if it's defined and not base
 ## need to add security check here
 &_do($_session{'go'}) if $_session{'go'} && $_session{'go'} ne $_base
                          && $_session{'go'}=~/^($_paochk)$/o;
 ## now do the base
 &_do($_base);
 &_do('end'); ## print html tail
 &_savestate; ## save session data
 ## delete expired session information sometimes
 &_sessioncleanup unless int(rand(100));
}

sub _do {
 local($a,$b)=@_; $b=$_redef{$a};
 #print "($a/$b) ";
 if($b) {do $b();} else {do $a()};
}

sub _selops { local($_,$name)=@_; ## need to support valued options...
 ($name)=/name *= *"([^"]+)"/i;
 ($name)=/name *= *(\w+)/i unless $name;
#print "db: $name/$_session{$name}:$_\n";
 if($_session{$name}) {
  s/<option selected>/<option>/gi; ## clear default selection if any
  s/(<option)(>$_session{"$name"}<)/$1 selected$2/i;
 }
#print "db: $name/$_session{$name}:$_\n";
 print $_;
}
sub _checkbox { local($_,$name,$v)=@_;
 #<input type="checkbox" checked name="C1" value="ON">
 #($name)=/name *= *"([^"]+)"/i || /name *= *(\w+)/i;
 if($v=$_session{$name}) {
  #print "$name=$v ";
  s/(<[^>]*) checked([^>]*)>/$1$2>/gi; # clear default checks
  for $sv (split(';',$v)) {
   s/(name *= *"?$name"?\s*value *= *"?$sv"?)/checked $1/gi;
  }
 }
 print $_;
}
#<input type="radio" checked name="R1" value="V1">
sub _radio { local($_,$name,$v)=@_;
 #($name)=/name *= *"([^"]+)"/i || /name *= *(\w+)/i;
 if($v=$_session{$name}) {
  s/(<[^>]*) checked([^>]*)>/$1$2>/gi; # clear default checks
  s/(name *= *"?$name"?\s*value *= *"?$v"?)/checked $1/gi;
 }
 print $_;
}

sub _fixup { local($_)=shift; # change code references appropriately
 s/&amp;/&/g; s/&gt;/>/g; s/&lt;/</g; s/&quot;/"/gi; s/&nbsp;/ /gi;
 s/<p>//ig; s/<\/p>//ig; s/<br>//gi;
 s/!!(\w+)/&_do('$1')/g;
 $_;
}
sub _code { $code[++$code]=&_fixup($1); "\001$code ";}
sub _code2 { $code[++$code]=$1; "\001$code ";}

sub _init { local($_);

# read cookie or set cookie 
($_sid)=$ENV{'HTTP_COOKIE'}=~/SID *= *(\w+)/;
#$_sid='COOK';
srand(time + $$);
unless ($_sid) {
 @l=('a'..'z','A'..'Z','0'..'9','_');
 for $n (1..10) {
  $_sid.=$l[int(rand($#l+1))];
 }
 print "Set-Cookie: SID=$_sid;\n";
# print "Set-Cookie: name, value, expires
# nam=value; expies=date; path=path; domain=don; secure
# date: wdy, dd-mon-yyyy hh:mm:ss gmt
# env{'cookie'} -> split(/[=;] */)
}
# read state info
(%_session)=split(/\001/,&rf($_sid_base.$_sid.$ENV{REMOTE_ADDR}));
#(%_session)=split(/\001/,$_sessions{$_sid.$ENV{REMOTE_ADDR}});

# verify source ip, state timeout
if( $_session{'_time'} && $_session{'_time'}<time-$_SID_TIMEOUT) {
 undef %_session;
}

# read cgi
{
 local(%c,$i,$v);
 read(STDIN,$_,$ENV{'CONTENT_LENGTH'}) || ($_=$ENV{'QUERY_STRING'});
 y/+&=/ \001\002/; s/%(..)/pack("c",hex($1))/ge; s/\r\n/\n/g;
 for (split(/\001/)) {
  ($i,$v)=split(/\002/);
  $c{$i}.=';' if $c{$i};
  $c{$i}.=$v;
 }
 for(keys %c) {
  $_session{$_}=$c{$_};
 }
}
$_myname=$ENV{'SCRIPT_NAME'};

$_url=$ENV{'SERVER_URL'}; chop($_url); $_url.=$_myname;

$_session{'_time'}=time;
print "Expires: " . &_now . "\n";
print "Content-type: text/html;\n\n";
}

sub _now {
 local($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = gmtime(time);
 return ('Sun','Mon','Tue','Wed','Thu','Fri','Sat')[$wday] . ", $mday " .
  ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec')[$mon] .
  ' ' . ($year + 1900) . sprintf(" %d:%02d:%02d GMT", $hour,$min,$sec);
}

sub _savestate {
# save state
#$_sessions{$_sid.$ENV{REMOTE_ADDR}}=join("\001",%_session);
&wf($_sid_base.$_sid.$ENV{REMOTE_ADDR},join("\001",%_session));
}
sub _sessioncleanup {
 opendir(D,$_sid_base);
 for (readdir(D)) {
  next if -d $_sid_base.$_;
  #print "unlink $_sid_base.$_ if ",time-(stat $_sid_base.$_)[8]," > $_SID_TIMEOUT\n";
  unlink $_sid_base.$_ if time-(stat $_sid_base.$_)[8] > $_SID_TIMEOUT;
 }
}
sub rf {local($_, $/); open(F,'<'.shift) && <F>;}
sub wf {open(F,'>'.shift) && print F shift; close F;}

sub clearsession {
undef %_session;
$_session{'_time'}=time;
}
sub sql { local($db,$s,$fr,$rv)=@_;
 &_sqllog(($_sql_save ne $s?'new':'cont')." $s");
 if($_sql_save ne $s) {
  $_sql_save=$s;
  unless ($_sql_sth=$db->prepare($s))
  {
   print "<pre>\nSQL Prepare Error: ",$db->errstr,"\n$_sql_save\n</pre>\n";
   &_sqllog("SQL Prepare Error: ".$db->errstr);
   return 0;
  }
  unless ($rv=$_sql_sth->execute())
  {
   print "<pre>\nSQL Execute Error: ",$db->errstr,"\n$_sql_save\n</pre>\n";
   &_sqllog("SQL Prepare Error: ".$db->errstr);
   return 0;
  }
 }
 if($s=~/^ *select/i) {
  $fr=$_sql_sth->fetchrow_hashref;
  &_sqllog("    ",join('|',%$fr));
  $_sql_save='' unless %$fr; # clear cache if end of results
  return %SQL=%$fr;
 } else {
  $_sql_save='';
  &_sqllog("    rv=$rv");
  return $rv eq '0E0'? 0:1;
 }
}
sub _sqllog {
 return unless $sqllog;
 open(SQLLOG,">>$sqllog");
 print SQLLOG join("\n",@_),"\n";
 close SQLLOG;
}
sub quote4url { local($_)=@_;
 s/([^._\~\-\/ a-zA-Z0-9])/'%'.unpack('H*',$1)/eg; s/ /+/g;
 $_;
}
sub quote4sql { local($_)=@_;
 s/\\/\\\\/g; s/\n/\\n/g; s/\r//g; s/'/\\'/; s/\]/\\]/g;
 $_;
}

sub badlanguage { local($_,$profanity)=@_;
 $profanity = 'fuck|bitch|\banus|butt\b|\bass\b|\bpenis|\bvulva|\bpussy|' .
 '\btitt\b|\btitts|\bmutha|\bshit|\bturd|\bpiss\b|dickhead|dickface|' .
 'dickless|dumbass|dammit|\bfuct\b|cocksuc|cock-suc|dicksuc|dick-suc|' .
 'dildo|whore|twat|nigger|\bcunt|asshole|rot\s*in\s*hell|\bslut\b|jerk\s*off|' .
 'masturbat|idiotic|freaking|\btwit\b|moronic|suck\s*m.\b|suck\s*you|' .
 'go\s*to\s*hell|really suck';
 /$profanity/io && $&;
}




sub Home {
 print "<h1>Wob Demo</h1>
<div align=\"center\"><center>

<table border=\"0\" width=\"100%\" bgcolor=\"#E8E8E8\">
    <tr>
        <td align=\"center\">";
&_do('top');
 print "</td>
    </tr>
</table>
</center></div>

<table border=\"1\" width=\"100%\" bgcolor=\"#FAD8BC\"
bordercolor=\"#000000\">
    <tr>
        <td width=\"20%\">";
&_do('leftside');
 print "</td>
        <td width=\"70%\" bgcolor=\"#F7EBC6\">";
&_do('middle');
 print "</td>
        <td align=\"right\" width=\"10%\">";
&_do('right');
 print "</td>
    </tr>
</table>

<p>This text appears at the bottom of all pages which don't
override &quot;Home&quot;</p> ";
}

sub features {
 print "<p>Click on this stuff to see what it does:</p>

<ul>
    <li><font size=\"1\"><a href=\"$_myname?go=Home\">Home</a></font></li>
    <li><font size=\"1\"><a href=\"$_myname?go=About\">About</a></font></li>
    <li><font size=\"1\"><a href=\"$_myname?go=Test\">Test</a></font></li>
    <li><font size=\"1\"><a href=\"$_myname?go=Test2\">Test2</a></font></li>
</ul> ";
}

sub exits {
 print "<p>Exits</p>

<ul>
    <li><a href=\"http://wob.sourceforge.net/\"><font size=\"1\">wob.sourceforge.net</font></a><font
        size=\"1\"> <br>
        -- back to the main wob page</font></li>
    <li><a href=\"http://everything.slashdot.org\"><font size=\"1\">Everything</font></a><font
        size=\"1\"> <br>
        -- another interesting project</font></li>
    <li><a href=\"http://www.zope.org\"><font size=\"1\">Zope</font></a><font
        size=\"1\"> <br>
        -- an even more interesting project</font></li>
</ul> ";
}

sub leftside {
 print "<p>";
&_do('features');
&_do('exits');
 print "</p> ";
}

sub top {
 print "<h1>Here is the top of this demo -- the default Top</h1> ";
}

sub right {
 print "<p>This is the text inserted into the right column. (Default
Right)</p> ";
}

sub middle {
 print "<p>This is the default middle text. Right here ";
$_session{a}++;
 print " i'm
incrementing \$ a. The number now is $_session{a}. (Default Middle)</p>

<p>Put some things in the form and post -- what you enter should
stay with you for the duration of the session. And the values are
inserted following.</p>

<form method=\"POST\">
    <table border=\"1\">
        <tr>
            <td align=\"center\">Text: <input type=\"text\" size=\"54\"
            name=\"T1\" value=\"$_session{T1}\"> </td>
            <td>T1=$_session{T1}</td>
        </tr>
        <tr>
            <td align=\"center\">More text: <textarea name=\"S1\"
            rows=\"5\" cols=\"30\">$_session{S1}</textarea></td>
            <td>S1=&quot;$_session{S1}&quot;</td>
        </tr>
        <tr>
            <td align=\"center\">";
 &_selops(qq{<select name="D1" size="1">
                <option>Frist Choice</option>
                <option>Second Choice</option>
                <option>Third Choice</option>
            });
 print "</select> </td>
            <td>D1=$_session{D1}</td>
        </tr>
        <tr>
            <td align=\"center\">";
 &_radio(qq{<input type="radio" name="R1"
            value="V1">},'R1');
 print "r1-v1<br> ";
 &_radio(qq{<input type="radio" name="R1" value="V2">},'R1');
 print "v2<br> ";
 &_radio(qq{<input type="radio" checked name="R1" value="V3">},'R1');
 print "v3<br> ";
 &_radio(qq{<input type="radio" name="R1" value="V4">},'R1');
 print "v4<br> ";
 &_radio(qq{<input type="radio" name="R1" value="V5">},'R1');
 print "v5</td>
            <td>R1=&quot;$_session{R1}&quot;</td>
        </tr>
        <tr>
            <td align=\"center\">";
 &_checkbox(qq{<input type="checkbox" name="c1"
            value="v1">},'c1');
 print "c1-v1<br> ";
 &_checkbox(qq{<input type="checkbox" checked name="c1" value="v2">},'c1');
 print "v2<br> ";
 &_checkbox(qq{<input type="checkbox" name="c1" value="v3">},'c1');
 print "v3</td>
            <td>c1=&quot;$_session{c1}&quot;</td>
        </tr>
    </table>
    <p><input type=\"submit\" name=\"go\" value=\"Home\"><input
    type=\"submit\" name=\"go\" value=\"About\"><input type=\"submit\"
    name=\"go\" value=\"Test2\"></p>
</form>

<p>&nbsp;</p> ";
}

sub About {
 $_redef{_middle}=($_redef{middle} || 'middle'); $_redef{middle}='About_middle';

sub About_middle {
 print "<h2>This is the about page.</h2>

<p>This is the Perl Web OBjects (wob) system. It's still totally
in development, but is gaining some useful features. The idea is
to define a modular web page with portions which can be redefined.
Click below to look at the source. </p>

<ul>
    <li>### defines a section</li>
    <li>## defines a redefinition. </li>
    <li>two left single quotes ` ` quote perl code </li>
    <li>\$ lets you insert variables from the session buffer. </li>
    <li>\$ SQL inserts a sql field.</li>
    <li>&sql(\$,qq[select ...;]) inserts a sql query.</li>
    <li>Form values retain their value in the session buffer as
        well.</li>
    <li>-&gt; lets you easily enter a link to a method</li>
    <li>form buttons use &quot;go&quot; to pick the target method
        for the post </li>
    <li>multivalues are separated by ;</li>
</ul> ";
}

}

sub Test {
 $_redef{_leftside}=($_redef{leftside} || 'leftside'); $_redef{leftside}='Test_leftside';

sub Test_leftside {
 print "<p>Test added this line to &quot;leftside&quot;</p>

<p>";
&_do('_leftside');
 print "</p> ";
}

 $_redef{_top}=($_redef{top} || 'top'); $_redef{top}='Test_top';

sub Test_top {
 print "<p>Test redefined &quot;top&quot; to be this.</p> ";
}

 $_redef{_right}=($_redef{right} || 'right'); $_redef{right}='Test_right';

sub Test_right {
 print "<p>Test redefined &quot;right&quot; to be this.</p> ";
}

}

sub Test2 {
 $_redef{_right}=($_redef{right} || 'right'); $_redef{right}='Test2_right';

sub Test2_right {
 print "<p>Test2 redefined the &quot;right&quot; to be this.</p> ";
}

}

sub end {
 print "<p>This text is inserted at the end of all pages no matter what.</p>

<p><a href=\"../wobdemo.htm\">View Source File</a> for these pages.
View <a href=\"../wob.txt\">Perl Source</a> for the filter.</p>
</body>
</html> ";
}
